# generated by datamodel-codegen:
#   filename:  data_room_action.json

from __future__ import annotations

from typing import Any, Mapping, Optional, Sequence, Union

from typing_extensions import Literal, NotRequired, TypedDict


class AudienceReference4(TypedDict):
    kind: Literal['BASE']


class AudienceReference5(TypedDict):
    id: str
    kind: Literal['CUSTOM']


class AudienceReference6(TypedDict):
    audienceType: str
    kind: Literal['SEED']


AudienceReference = Union[AudienceReference4, AudienceReference5, AudienceReference6]


BooleanOp = Literal['AND', 'OR']


CombineOperator = Literal['INTERSECT', 'UNION', 'DIFF']


class CustomAudienceDefinition(TypedDict):
    excludeSeedAudience: NotRequired[Optional[bool]]
    kind: Literal['LOOKALIKE']
    reach: int
    sourceRef: AudienceReference


FilterOperator = Literal[
    'CONTAINS_ANY_OF', 'CONTAINS_NONE_OF', 'CONTAINS_ALL_OF', 'EMPTY', 'NOT_EMPTY'
]


class ProvisionBaseAudiencePolicyIds(TypedDict):
    demographicsPolicyId: NotRequired[Optional[str]]
    embeddingsPolicyId: NotRequired[Optional[str]]
    matchingPolicyId: str
    segmentsPolicyId: NotRequired[Optional[str]]


class MediaDcrAction1(TypedDict):
    provisionBaseAudiencePolicyIds: ProvisionBaseAudiencePolicyIds


class MediaDcrAction2(TypedDict):
    deprovisionBaseAudiencePolicyIds: Mapping[str, Any]


class ProvisionSeedAudiencePolicyIds(TypedDict):
    audiencesPolicyId: str


class MediaDcrAction3(TypedDict):
    provisionSeedAudiencePolicyIds: ProvisionSeedAudiencePolicyIds


class MediaDcrAction4(TypedDict):
    deprovisionSeedAudiencePolicyIds: Mapping[str, Any]


class DeleteCustomAudience(TypedDict):
    audienceId: str
    forceDeletePrerequisites: bool


class MediaDcrAction6(TypedDict):
    deleteCustomAudience: DeleteCustomAudience


class GetAudiencePrerequisites(TypedDict):
    audienceId: str


class MediaDcrAction7(TypedDict):
    getAudiencePrerequisites: GetAudiencePrerequisites


class AudienceFilter(TypedDict):
    attribute: str
    operator: FilterOperator
    values: NotRequired[Sequence[str]]


class AudienceFilters(TypedDict):
    booleanOp: BooleanOp
    filters: Sequence[AudienceFilter]


class AudienceCombinator(TypedDict):
    filters: NotRequired[Optional[AudienceFilters]]
    operator: CombineOperator
    sourceRef: AudienceReference


class CustomAudienceDefinition5(TypedDict):
    combine: NotRequired[Sequence[AudienceCombinator]]
    filters: NotRequired[Optional[AudienceFilters]]
    kind: Literal['RULE_BASED']
    sourceRef: AudienceReference


CustomAudienceDefinition3 = Union[CustomAudienceDefinition, CustomAudienceDefinition5]


class CreateCustomAudience(TypedDict):
    definition: CustomAudienceDefinition3
    name: str
    sharedWith: Sequence[str]


class MediaDcrAction5(TypedDict):
    createCustomAudience: CreateCustomAudience


class UpdateCustomAudience(TypedDict):
    audienceId: str
    definition: NotRequired[Optional[CustomAudienceDefinition3]]
    name: NotRequired[Optional[str]]
    sharedWith: NotRequired[Sequence[str]]


class MediaDcrAction8(TypedDict):
    updateCustomAudience: UpdateCustomAudience


MediaDcrAction = Union[
    MediaDcrAction1,
    MediaDcrAction2,
    MediaDcrAction3,
    MediaDcrAction4,
    MediaDcrAction5,
    MediaDcrAction6,
    MediaDcrAction7,
    MediaDcrAction8,
]


class DataRoomAction1(TypedDict):
    media: MediaDcrAction


DataRoomAction = DataRoomAction1
